#!/bin/bash

##echo "novell-ncl-autologin" 
# YaST Configuration file
SYS_LOGIN="/etc/opt/novell/ncl/login.conf"
CONF_STARTUP="`echo $HOME`/.novell/ncl/StartupLogin.conf"
CONF_MAPS="`echo $HOME`/.novell/ncl/StartupMaps.conf"

# desktop file for KDE autostart
AUTOSTART="ncl_autologin.desktop"
SOURCELNK="/opt/novell/ncl/bin/$AUTOSTART"
# autostart file for Gnome
GNOME_CMD="gnome-login.bsh"

# setting up PATH variable
if [ -z `echo $PATH | grep "/opt/novell/ncl/bin"` ];then
    export PATH="$PATH:/opt/novell/ncl/bin"
fi;


disable_autostart() {
##echo "-- disable ncl integrated login ---"
# Remove GNOME autostart
if [ -f "$HOME/.gnome2/session-manual" -a `grep "/opt/novell/ncl/bin/$GNOME_CMD" $HOME/.gnome2/session-manual | wc -l` -gt 0 ]; then
    NUMBER=`cat $HOME/.gnome2/session-manual | grep 'num_clients' | cut -d= -f2`
    ID=`grep "/opt/novell/ncl/bin/$GNOME_CMD" $HOME/.gnome2/session-manual | cut -f1 -d,`

    let NUMBER-=1

    perl -pi -e "s|num_clients=[0-9]+|num_clients=$NUMBER|" $HOME/.gnome2/session-manual
    perl -pi -e "s|^$ID,.*?\n||gsx" $HOME/.gnome2/session-manual
    
fi
# Remove new gnome autostart desktop file
if [ -f $HOME/.config/autostart/$AUTOSTART]; then
   rm -f $HOME/.config/autostart/$AUTOSTART
fi

# Remove KDE autostart
if [ -f "$HOME/.kde/Autostart/`basename $SOURCELNK`" ]; then
    rm -f "$HOME/.kde/Autostart/`basename $SOURCELNK`"
fi

}

enable_autostart(){
##echo "-- enable ncl integrated login ---"
# GNOME autostart
if [ -d "$HOME/.config/autostart" ]; then
    cp -f $SOURCELNK $HOME/.config/autostart/
else
# if the .config/autostart does not exist, them modify/create a .gnome2/session-manual to startup the novell login
[ -d "$HOME/.gnome2" ] || mkdir $HOME/.gnome2

if [ ! -f "$HOME/.gnome2/session-manual" ]; then
#echo "--create new file $HOME/.gnome2/session-manual, and initialize it"
cat >$HOME/.gnome2/session-manual 2>&1 <<-END

[Default]
num_clients=1
0,RestartStyleHint=3
0,Priority=50
0,RestartCommand=/opt/novell/ncl/bin/$GNOME_CMD
END

else
#echo "file $HOME/.gnome2/session-manual already exists"
    NUMBER=`cat $HOME/.gnome2/session-manual | grep 'num_clients' | cut -d= -f2`

    if [ `cat  $HOME/.gnome2/session-manual | grep "$GNOME_CMD" | wc -l` -eq 0 ]; then
#echo "insert $GNOME_CMD stuff"    
cat  >>$HOME/.gnome2/session-manual <<END
$NUMBER,RestartStyleHint=3
$NUMBER,Priority=50
$NUMBER,RestartCommand=/opt/novell/ncl/bin/$GNOME_CMD
END

	let NUMBER+=1

	perl -pi -e "s|num_clients=[0-9]+|num_clients=$NUMBER|" $HOME/.gnome2/session-manual
#else
#echo "$GNOME_CMD already exists"
    fi
fi

fi

# KDE autostart
# does generic autostart directory exist?
if [ -d "$HOME/.config/autostart" ]; then
# if it exists, remove possible duplicate startup file
   if [ -d "$HOME/.kde" ]; then
      rm -f $HOME/.kde/Autostart/$SOURCELNK
   fi
else
# no generic autostart directory exists, 
# make kde home directory (.kde/Autostart), and copy my autostart file into it.
  [ -d "$HOME/.kde" ] || mkdir $HOME/.kde
  if [ -d "$HOME/.kde" ]; then
      [ -d "$HOME/.kde/Autostart" ] || mkdir $HOME/.kde/Autostart
     cp -f $SOURCELNK $HOME/.kde/Autostart/
  fi
fi
}

# insert excludeApps
if [ ! -f "$HOME/.kde/share/config/ksmserverrc" ]; then
    mkdir -p $HOME/.kde/share/config
    touch $HOME/.kde/share/config/ksmserverrc
fi

if [ `grep '\[General\]' $HOME/.kde/share/config/ksmserverrc | wc -l` -eq 0 ]; then
    echo -e "\n[General]" >> $HOME/.kde/share/config/ksmserverrc
    echo "excludeApps=ncl_autologin" >> $HOME/.kde/share/config/ksmserverrc
else
    if [ `grep 'excludeApps' $HOME/.kde/share/config/ksmserverrc | wc -l` -eq 0 ]; then
	perl -pi -e "s|\[General\]|\[General\]\nexcludeApps=ncl_autologin|" $HOME/.kde/share/config/ksmserverrc
    else
	if [ `grep '^excludeApps=.*ncl_autologin' $HOME/.kde/share/config/ksmserverrc | wc -l` -eq 0 ]; then
	    perl -pi -e 's|excludeApps=(.*)|excludeApps=ncl_autologin:$1|' $HOME/.kde/share/config/ksmserverrc
	fi
    fi
fi

# default GLOBAL setting in config file is ON, if config file exists, check for off 
OK="yes"

#test if global config file exists, if not, the default is to run integrated login
if [ -f $SYS_LOGIN ]; then
   # did we specifically find the line to not run?
	if [ `grep 'Allow_Integrated_Login=false' $SYS_LOGIN | wc -l` -gt 0 ]; then
         if [ ! -f $CONF_MAPS ]; then
            OK="no"
##            echo "admin specified no autologin"
         fi
	fi
fi

# default LOCAL setting in the config file (if not there) is 'off'
if [ $OK == "yes" ]; then
   if [ -f $CONF_STARTUP ]; then
      # did we specifically find the line to not run?
      if [ `grep 'RunScripts = yes' $CONF_STARTUP | wc -l` -gt 0 ]; then
         OK="yes"
      else
         OK="no"
##         echo "local RunScripts disabled autologin of scripts"
      fi
   else
         OK="no"
##         echo "no local autologin configuration"
   fi
   
fi

if [ -f $CONF_MAPS ]; then
   OK="yes"
fi

##echo "value = $OK"
if [ $HOME != "/root" ]; then
   if [ $OK == "yes" ]; then
      enable_autostart
   else
      disable_autostart
   fi
fi

